import fastapi as fa
from fastapi import HTTPException, status

from .user.services import TokenService, oauth2_scheme
from db.repositories import UserRepository
from db.models import UserRoleEnum


token_service = TokenService()

user_repo = UserRepository()


async def get_user_role(token: str = fa.Security(oauth2_scheme)):
    token_data = token_service.decode_token(token)

    if token_data.role == UserRoleEnum.system_consumer:
        return await user_repo.get(id=token_data.sub)

    raise HTTPException(
        status_code=status.HTTP_401_UNAUTHORIZED,
        detail="Not authenticated",
        headers={"WWW-Authenticate": "Bearer"},
    )
